HDU 1258 Sum It Up

来源:互联网 发布:数据分析师 挂靠 编辑:程序博客网 时间:2024/06/11 14:55

Sum It Up

Problem Description
Given a specified total t and a list of n integers, find all distinct sums using numbers from the list that add up to t. For example, if t=4, n=6, and the list is [4,3,2,2,1,1], then there are four different sums that equal 4: 4,3+1,2+2, and 2+1+1.(A number can be used within a sum as many times as it appears in the list, and a single number counts as a sum.) Your job is to solve this problem in general.
 
Input
The input will contain one or more test cases, one per line. Each test case contains t, the total, followed by n, the number of integers in the list, followed by n integers x1,...,xn. If n=0 it signals the end of the input; otherwise, t will be a positive integer less than 1000, n will be an integer between 1 and 12(inclusive), and x1,...,xn will be positive integers less than 100. All numbers will be separated by exactly one space. The numbers in each list appear in nonincreasing order, and there may be repetitions.
 
Output
For each test case, first output a line containing 'Sums of', the total, and a colon. Then output each sum, one per line; if there are no sums, output the line 'NONE'. The numbers within each sum must appear in nonincreasing order. A number may be repeated in the sum as many times as it was repeated in the original list. The sums themselves must be sorted in decreasing order based on the numbers appearing in the sum. In other words, the sums must be sorted by their first number; sums with the same first number must be sorted by their second number; sums with the same first two numbers must be sorted by their third number; and so on. Within each test case, all sums must be distince; the same sum connot appear twice.
 
Sample Input
4 6 4 3 2 2 1 15 3 2 1 1400 12 50 50 50 50 50 50 25 25 25 25 25 250 0 

Sample Output
Sums of 4:43+12+22+1+1Sums of 5:NONESums of 400:50+50+50+50+50+50+25+25+25+2550+50+50+50+50+25+25+25+25+25+25
题意:给出一个数n,输入一个m,后面跟m个数,从这些数中找记起来等于n的,每个数在式子里只能出现一次,例如第一个例子,有两个二,所以下面每个2最多在一个式子中输出2个,相同的式子只输出一个,比如第一个例子,因为有两个2,所以2+1+1这个式子本来有两个,一样,所以只输出一个。

显然遇到这种给一排数,求固定的和,一个一个筛选,深度优先搜索。

#include<stdio.h>#include<string.h>#include<algorithm>using namespace std;int a[15];int S,n,Q;int mark[15];bool cmp(int a,int b){    return a>b;}void dfs(int I,int J,int sum){    int i,k;    if(sum==S)    {        Q++;        printf("%d",mark[0]);        for(k=1; k<J; k++)        {            printf("+%d",mark[k]);        }        printf("\n");    }    else if(sum<S)    {        for(i=I; i<n; i++)        {            mark[J]=a[i];            dfs(i+1,J+1,sum+a[i]);            while(i+1&&a[i]==a[i+1])            i++;        }    }    else    {        return;    }}int main(){    int i;    while(~scanf("%d%d",&S,&n)&&S+n)    {        for(i=0; i<n; i++)            scanf("%d",&a[i]);        sort(a,a+n,cmp);        Q=0;        printf("Sums of %d:\n",S);        dfs(0,0,0);        if(!Q)        printf("NONE\n");    }    return 0;}





1 0
原创粉丝点击